<?php

// Reminder: always indent with 4 spaces (no tabs).
// +---------------------------------------------------------------------------+
// | Navigation Manager - Navman Plugin for Geeklog                            |
// +---------------------------------------------------------------------------+
// | plugins/navman/filters.php                                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 dengen - taharaxp AT gmail DOT com                     |
// |                                                                           |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett               -    twillett AT users DOT sourceforge DOT net  |
// | Blaine Lang               -    langmail AT sympatico DOT ca               |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                -    tony AT tonybibbs DOT com                  |
// | Modified by:                                                              |
// | mystral-kk                -    geeklog AT mystral-kk DOT net              |
// | dengen                    -    taharaxp AT gmail DOT com                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

if (strpos(strtolower($_SERVER['PHP_SELF']), 'filters.php') !== false) {
    die('This file can not be used on its own.');
}

function phpfilter_contribute(&$A)
{
    global $_CONF, $LANG01, $topic;

    if (empty($topic)) {
        $A['url'] = $_CONF['site_url'] . '/submit.php?type=story';
    } else {
        $A['url'] = $_CONF['site_url'] . '/submit.php?type=story&amp;topic=' . $topic;
    }
    $A['label'] = $LANG01[71];
    $A['label_var'] = '';
}


function phpfilter_login(&$A)
{
    global $_CONF, $_USER, $LANG01;

    if (!empty($_USER['uid']) && ($_USER['uid'] > 1)) {
        $A['url'] = $_CONF['site_url'] . '/users.php?mode=logout';
        $A['label'] = $LANG01[19];
    } else {
        $A['url'] = $_CONF['site_url'] . '/users.php?mode=login';
        $A['label'] = $LANG01[47];
    }
    $A['label_var'] = '';
}


function phpfilter_staticpage(&$A)
{
    global $_CONF, $_TABLES;

    $sp_id = $A['contentid'];
    $A['label'] = DB_getItem($_TABLES['staticpage'], 'sp_title', "sp_id = '" . addslashes($sp_id) . "'");
    if ($A['label'] != false) {
        $A['url'] = COM_buildURL($_CONF['site_url'] . '/staticpages/index.php?page=' . $sp_id);
    } else {
        $A['label'] = 'noname';
        $A['url'] = $_CONF['site_url'] . '/';
    }
}


function phpfilter_bc_admin(&$A)
{
    global $_CONF, $_TABLES, $_NAVM_CONF,
           $LANG29, $LANG24, $LANG21, $LANG27, $LANG28,
           $LANG_ACCESS, $LANG31, $LANG33,
           $LANG_TRB, $LANG32, $LANG_DB_BACKUP, $LANG_CONFIG;

    if (!$A['bc']) return;
    preg_match('@/admin/?([^/]+)\.php@i', $_NAVM_CONF['current_url'], $matches);
    $op = $matches[1];
    if (!empty($op)) {
        $A['url'] = $_CONF['site_url'] . '/admin/'. $op . '.php';
        switch ($op) {
            case 'moderation':    $A['label'] = $LANG29[34]; break;
            case 'configuration': $A['label'] = $LANG_CONFIG['sections']; break;
            case 'story':         $A['label'] = $LANG24[22]; break;
            case 'block':         $A['label'] = $LANG21[19]; break;
            case 'topic':         $A['label'] = $LANG27[8];  break;
            case 'user':          $A['label'] = $LANG28[11]; break;
            case 'group':         $A['label'] = $LANG_ACCESS['groupmanager']; break;
            case 'mail':          $A['label'] = $LANG31[1];  break;
            case 'syndication':   $A['label'] = $LANG33[10]; break;
            case 'trackback':     $A['label'] = $LANG_TRB['services_headline']; break;
            case 'plugins':       $A['label'] = $LANG32[5];  break;
            case 'database':      $A['label'] = $LANG_DB_BACKUP['last_ten_backups']; break;
            default:              $A['label'] = $op;         break;
        }
    }
}

function phpfilter_bc_admin_plugin(&$A)
{
    global $_CONF, $_TABLES, $_NAVM_CONF,
           $LANG_LINKS_ADMIN, $LANG25, $LANG_NAVM, $LANG_CALJP_ADMIN, $LANG_CAL_ADMIN,
           $LANG_JPN, $LANG_CP00, $LANG_GF06, $LANG_configsections, $LANG_DPXY,
           $LANG_DBMAN, $LANG_FILEMGMT, $LANG_MYCALJP, $LANG_NMOXTOPICOWN, $LANG_SMAP,
           $LANG_STATIC, $LANG_THM, $LANG_TKGMAPS, $LANG_DLM, $LANG_MG00;

    if (!$A['bc']) return;
    preg_match('@/admin/plugins/([^/]+)/([^/]+)\.php@', $_NAVM_CONF['current_url'], $matches);
    $pn = $matches[1];
    $op = $matches[2];
    if (!empty($pn)) {
        $A['url'] = $_CONF['site_url'] . '/admin/plugins/'. $pn . '/' . $op. '.php';
        switch ($pn) {
            case 'autotags':     $A['label'] = 'Autotags'; break;
            case 'calendar':     $A['label'] = $LANG_CAL_ADMIN[11]; break;
            case 'calendarjp':   $A['label'] = $LANG_CALJP_ADMIN[11]; break;
            case 'captcha':      $A['label'] = $LANG_CP00['admin']; break;
            case 'navman':       $A['label'] = $LANG_NAVM['manager']; break;
            case 'dataproxy':    $A['label'] = $LANG_DPXY['admin']; break;
            case 'dbman':        $A['label'] = $LANG_DBMAN['dbman']; break;
            case 'downloads':    $A['label'] = $LANG_DLM['manager']; break;
            case 'filemgmt':     $A['label'] = $LANG_FILEMGMT['admin_menu']; break;
            case 'forum':        $A['label'] = $LANG_GF06[3]; break;
            case 'japanize':     $A['label'] = $LANG_JPN['piname']; break;
            case 'links':        $A['label'] = $LANG_LINKS_ADMIN[11]; break;
            case 'mediagallery': $A['label'] = $LANG_MG00['admin']; break;
            case 'mycaljp':      $A['label'] = $LANG_MYCALJP['admin']; break;
            case 'nmoxtopicown': $A['label'] = $LANG_NMOXTOPICOWN['nmoxtopicown']; break;
            case 'polls':        $A['label'] = $LANG25[18]; break;
            case 'sitemap':      $A['label'] = $LANG_SMAP['admin']; break;
            case 'spamx':        $A['label'] = $LANG_configsections['spamx']['label']; break;
            case 'staticpages':  $A['label'] = $LANG_STATIC['staticpagelist']; break;
            case 'themedit':     $A['label'] = $LANG_THM['admin']; break;
            case 'tkgmaps':      $A['label'] = $LANG_TKGMAPS['manager']; break;
            default:             $A['label'] = $pn; break;
        }
    }
}

function phpfilter_bc_plugin(&$A)
{
    global $_CONF, $_TABLES, $_NAVM_CONF, $_NAVM_plugin_label_var;

    if (!$A['bc']) return;
    preg_match('@(?<!plugins)/([^/]+)/([^/]+)\.php(.*)@', $_NAVM_CONF['current_url'], $matches);
    if (!empty($matches[1])) {
        $A['url'] = $_CONF['site_url'] . '/'. $matches[1] . '/' . $matches[2]. '.php' . $matches[3];
        $A['label'] = $matches[1];
        if (!empty($_NAVM_plugin_label_var[$matches[1]])) {
            $A['label'] = NAVM_replaceLabel($_NAVM_plugin_label_var[$matches[1]]);
            if (empty($A['label'])) $A['label'] = $matches[1];
        }
    }
}

function phpfilter_bc_article(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $sid = COM_applyFilter(COM_getArgument('story'));
    $A['url'] = COM_buildURL($_CONF['site_url'] . '/article.php?story=' . $sid);
    $A['label'] = DB_getItem($_TABLES['stories'], 'title', "sid = '" . addslashes($sid) . "'");
}

function phpfilter_bc_topic(&$A)
{
    global $_CONF, $_TABLES, $topic;

    if (!$A['bc']) return;
    $A['url'] = $_CONF['site_url'] . '/index.php?topic=' . $topic;
    $A['label'] = DB_getItem($_TABLES['topics'], 'topic', "tid = '" . addslashes($topic) . "'");
}

function phpfilter_bc_staticpage(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $sp_id = $A['contentid'];
    $A['label'] = DB_getItem($_TABLES['staticpage'], 'sp_title', "sp_id = '" . addslashes($sp_id) . "'");
    if ($A['label'] != false) {
        $A['url'] = COM_buildURL($_CONF['site_url'] . '/staticpages/index.php?page=' . $sp_id);
    } else {
        $A['label'] = 'noname';
        $A['url'] = $_CONF['site_url'] . '/';
    }
}

function phpfilter_bc_links_category(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $cat_id = COM_applyFilter(COM_getArgument('category'));
    $A['url'] = $_CONF['site_url'] . '/links/index.php?category=' . $cat_id;
    $A['label'] = DB_getItem($_TABLES['linkcategories'], 'category', "cid = '" . addslashes($cat_id) . "'");
    if (empty($A['label'])) $A['label'] = $cat_id;
}

function phpfilter_bc_polls_topic(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $pid = COM_applyFilter(COM_getArgument('pid'));
    $A['url'] = $_CONF['site_url'] . '/polls/index.php?pid=' . $pid;
    $A['label'] = DB_getItem($_TABLES['polltopics'], 'topic', "pid = '" . addslashes($pid) . "'");
    if (empty($A['label'])) $A['label'] = $pid;
}

function phpfilter_bc_calendarjp_event(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $eid = COM_applyFilter(COM_getArgument('eid'));
    $A['url'] = $_CONF['site_url'] . '/calendarjp/event.php?eid=' . $eid;
    $A['label'] = DB_getItem($_TABLES['eventsjp'], 'title', "eid = '" . addslashes($eid) . "'");
    if (empty($A['label'])) $A['label'] = $eid;
}

function phpfilter_bc_calendar_event(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $eid = COM_applyFilter(COM_getArgument('eid'));
    $A['url'] = $_CONF['site_url'] . '/calendar/event.php?eid=' . $eid;
    $A['label'] = DB_getItem($_TABLES['events'], 'title', "eid = '" . addslashes($eid) . "'");
    if (empty($A['label'])) $A['label'] = $eid;
}

function phpfilter_bc_filemgmt_category(&$A)
{
    global $_CONF, $_FM_TABLES;

    if (!$A['bc']) return;
    $cid = COM_applyFilter(COM_getArgument('cid'));
    if (empty($cid)) {
        COM_setArgNames(array('id'));
        $id = COM_applyFilter(COM_getArgument('id'));
        $cid = DB_getItem($_FM_TABLES['filemgmt_filedetail'], 'cid', "lid = '" . addslashes($id) . "'");
    }
    $A['url'] = $_CONF['site_url'] . '/filemgmt/viewcat.php?cid=' . $cid;
    $A['label'] = DB_getItem($_FM_TABLES['filemgmt_cat'], 'title', "cid = '" . addslashes($cid) . "'");
    if (empty($A['label'])) $A['label'] = $cid;
}

function phpfilter_bc_filemgmt_file(&$A)
{
    global $_CONF, $_FM_TABLES;

    if (!$A['bc']) return;
    COM_setArgNames(array('id'));
    $id = COM_applyFilter(COM_getArgument('id'));
    $A['url'] = $_CONF['site_url'] . '/filemgmt/index.php?id=' . $id;
    $A['label'] = DB_getItem($_FM_TABLES['filemgmt_filedetail'], 'title', "lid = '" . addslashes($id) . "'");
    if (empty($A['label'])) $A['label'] = $id;
}



function phpfilter_bc_forum_etc(&$A)
{
    global $_CONF, $_TABLES, $_NAVM_CONF, $LANG_GF01, $LANG_GF02;

    if (!$A['bc']) return;
    preg_match('@(?<!plugins)/forum/(index|userprefs|notify|memberlist)\.php(.*)@',
               $_NAVM_CONF['current_url'], $matches);
    $op  = $matches[1];
    $op2 = $matches[2];
    if (!empty($op)) {
        $A['url'] = $_CONF['site_url'] . '/forum/' . $op . '.php' . $op2;
        switch ($op) {
            case 'userprefs':  $A['label'] = $LANG_GF01['USERPREFS'];     break;
            case 'notify':     $A['label'] = $LANG_GF01['SUBSCRIPTIONS']; break;
            case 'memberlist': $A['label'] = $LANG_GF02['msg200'];        break;
            case 'index':
                if ($op2 == '?op=popular') 
                               $A['label'] = $LANG_GF02['msg201'];        break;
            default:           $A['label'] = $op;                         break;
        }
    }
}

function phpfilter_bc_forum_category(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $topic_id = COM_applyFilter(COM_getArgument('showtopic'));
    if (!empty($topic_id)) {
        $forum_id = DB_getItem($_TABLES['gf_topic'], 'forum', "id = '" . addslashes($topic_id) . "'");
    } else {
        $forum_id = COM_applyFilter(COM_getArgument('forum'));
    }
    if (!empty($forum_id)) {
        $forum_cat = DB_getItem($_TABLES['gf_forums'], 'forum_cat', "forum_id = '" . addslashes($forum_id) . "'");
    }
    if (!empty($forum_cat)) {
        $A['url'] = $_CONF['site_url'] . '/forum/index.php';
        $A['label'] = DB_getItem($_TABLES['gf_categories'], 'cat_name', "id = '" . addslashes($forum_cat) . "'");
    }
}

function phpfilter_bc_forum_name(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $topic_id = COM_applyFilter(COM_getArgument('showtopic'));
    if (!empty($topic_id)) {
        $forum_id = DB_getItem($_TABLES['gf_topic'], 'forum', "id = '" . addslashes($topic_id) . "'");
    } else {
        $forum_id = COM_applyFilter(COM_getArgument('forum'));
    }
    if (!empty($forum_id)) {
        $A['url'] = $_CONF['site_url'] . '/forum/index.php?forum=' . $forum_id;
        $A['label'] = DB_getItem($_TABLES['gf_forums'], 'forum_name', "forum_id = '" . addslashes($forum_id) . "'");
    }
}

function phpfilter_bc_forum_topic(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $topic_id = COM_applyFilter(COM_getArgument('showtopic'));
    if (!empty($topic_id)) {
        $A['url'] = $_CONF['site_url'] . '/forum/viewtopic.php?showtopic=' . $topic_id;
        $A['label'] = DB_getItem($_TABLES['gf_topic'], 'subject', "id = '" . addslashes($topic_id) . "'");
    }
}

function phpfilter_bc_downloads_category(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $cid = COM_applyFilter(COM_getArgument('cid'));
    if (empty($cid)) {
        COM_setArgNames(array('id'));
        $id = COM_applyFilter(COM_getArgument('id'));
        $cid = DB_getItem($_TABLES['downloads'], 'cid', "lid = '" . addslashes($id) . "'");
    }
    $A['url'] = $_CONF['site_url'] . '/downloads/index.php?cid=' . $cid;
    $A['label'] = DB_getItem($_TABLES['downloadcategories'], 'title', "cid = '" . addslashes($cid) . "'");
    if (empty($A['label'])) $A['label'] = $cid;
}

function phpfilter_bc_downloads_file(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    COM_setArgNames(array('id'));
    $id = COM_applyFilter(COM_getArgument('id'));
    $A['url'] = COM_buildURL($_CONF['site_url'] . '/downloads/index.php?id=' . $id);
    $A['label'] = DB_getItem($_TABLES['downloads'], 'title', "lid = '" . addslashes($id) . "'");
    if (empty($A['label'])) $A['label'] = $id;
}

function phpfilter_bc_mediagallery_album(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $aid = COM_applyFilter(COM_getArgument('aid'));
    if (empty($aid)) {
        $id = COM_applyFilter(COM_getArgument('s'));
        $aid = DB_getItem($_TABLES['mg_media_albums'], 'album_id', "media_id = '" . addslashes($id) . "'");
    }
    $A['url'] = $_CONF['site_url'] . '/mediagallery/album.php?aid=' . $aid;
    $A['label'] = DB_getItem($_TABLES['mg_albums'], 'album_title', "album_id = '" . addslashes($aid) . "'");
    if (empty($A['label'])) $A['label'] = $aid;
}

function phpfilter_bc_mediagallery_media(&$A)
{
    global $_CONF, $_TABLES;

    if (!$A['bc']) return;
    $id = COM_applyFilter(COM_getArgument('s'));
    $A['url'] = $_CONF['site_url'] . '/mediagallery/media.php?s=' . $id;
    $A['label'] = DB_getItem($_TABLES['mg_media'], 'media_title', "media_id = '" . addslashes($id) . "'");
    if (empty($A['label'])) $A['label'] = $id;
}

?>