<?php

// Reminder: always indent with 4 spaces (no tabs).
// +---------------------------------------------------------------------------+
// | Navigation Manager - Navman Plugin for Geeklog                            |
// +---------------------------------------------------------------------------|
// | plugins/navman/install_defaults.php                                       |
// +---------------------------------------------------------------------------|
// | Copyright (C) 2009 dengen - taharaxp AT gmail DOT com                     |
// |                                                                           |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett               -    twillett AT users DOT sourceforge DOT net  |
// | Blaine Lang               -    langmail AT sympatico DOT ca               |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                -    tony AT tonybibbs DOT com                  |
// | Modified by:                                                              |
// | mystral-kk                -    geeklog AT mystral-kk DOT net              |
// | dengen                    -    taharaxp AT gmail DOT com                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

if (strpos(strtolower($_SERVER['PHP_SELF']), 'install_defaults.php') !== false) {
    die('This file can not be used on its own!');
}

/*
 * Navigation Manager default settings
 *
 * Initial Installation Defaults used when loading the online configuration
 * records. These settings are only used during the initial installation
 * and not referenced any more once the plugin is installed
 *
 */

global $_NAVM_DEFAULT;

$_NAVM_DEFAULT = array(
    'default_permissions' => array (3, 2, 2, 2),
    'prefix_id'           => 'navmitem-',
    'enable_breadcrumbs'  => '1',
    'current_with_link'   => '0',
    'show_bc_inhome'      => '1',
    'templatevar'         => array('header_navigation', 'footer_navigation', 'breadcrumbs'),
    'tagname'             => 'navi',
    'menuitem_group'      => array('global_items', 'local_items', 'breadcrumbs'),
    'use_theme'           => '0',
);

/**
* Initialize Navigation Manager plugin configuration
*
* Creates the database entries for the configuation if they don't already
* exist. Initial values will be taken from $_NAVM_CONF if available (e.g. from
* an old config.php), uses $_NAVM_DEFAULT otherwise.
*
* @return   boolean     true: success; false: an error occurred
*
*/
function plugin_initconfig_navman()
{
    global $_NAVM_CONF, $_NAVM_DEFAULT;

    if (is_array($_NAVM_CONF) && (count($_NAVM_CONF) > 1)) {
        $_NAVM_DEFAULT = array_merge($_NAVM_DEFAULT, $_NAVM_CONF);
    }

    $c = config::get_instance();
    $n = 'navman';
    $o = 0;
    if ($c->group_exists($n)) return true;
    $c->add('sg_main',             NULL,                                  'subgroup', 0, 0, NULL, 0,    true, $n);
    // ----------------------------------
    $c->add('fs_main',             NULL,                                  'fieldset', 0, 0, NULL, 0,    true, $n);
    $c->add('prefix_id',           $_NAVM_DEFAULT['prefix_id'],           'text',     0, 0, 0,    $o++, true, $n);
    $c->add('tagname',             $_NAVM_DEFAULT['tagname'],             'text',     0, 0, 0,    $o++, true, $n);
    $c->add('templatevar',         $_NAVM_DEFAULT['templatevar'],         '%text',    0, 0, NULL, $o++, true, $n);
    $c->add('menuitem_group',      $_NAVM_DEFAULT['menuitem_group'],      '%text',    0, 0, NULL, $o++, true, $n);
    $c->add('use_theme',           $_NAVM_DEFAULT['use_theme'],           'select',   0, 0, 0,    $o++, true, $n);
    // ----------------------------------
    $c->add('fs_breadcrumbs',      NULL,                                  'fieldset', 0, 1, NULL, 0,    true, $n);
    $c->add('enable_breadcrumbs',  $_NAVM_DEFAULT['enable_breadcrumbs'],  'select',   0, 1, 0,    $o++, true, $n);
    $c->add('current_with_link',   $_NAVM_DEFAULT['current_with_link'],   'select',   0, 1, 0,    $o++, true, $n);
    $c->add('show_bc_inhome',      $_NAVM_DEFAULT['show_bc_inhome'],      'select',   0, 1, 0,    $o++, true, $n);
    // ----------------------------------
    $c->add('fs_permissions',      NULL,                                  'fieldset', 0, 2, NULL, 0,    true, $n);
    $c->add('default_permissions', $_NAVM_DEFAULT['default_permissions'], '@select',  0, 2, 12,   $o++, true, $n);

    return true;
}

?>