<?php

// Reminder: always indent with 4 spaces (no tabs).
// +---------------------------------------------------------------------------+
// | Navigation Manager - Navman Plugin for Geeklog                            |
// +---------------------------------------------------------------------------+
// | plugins/navman/sql/mysql_install.php                                      |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 dengen - taharaxp AT gmail DOT com                     |
// |                                                                           |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett               -    twillett AT users DOT sourceforge DOT net  |
// | Blaine Lang               -    langmail AT sympatico DOT ca               |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                -    tony AT tonybibbs DOT com                  |
// | Modified by:                                                              |
// | mystral-kk                -    geeklog AT mystral-kk DOT net              |
// | dengen                    -    taharaxp AT gmail DOT com                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

$_SQL[] = "
CREATE TABLE {$_TABLES['navmmenus']} (
  nid varchar(40) NOT NULL default '',
  gid tinyint(1) NOT NULL default '1',
  name varchar(48) default NULL,
  is_enabled tinyint(1) unsigned NOT NULL default '1',
  php_function varchar(48) default NULL,
  tid varchar(20) NOT NULL default 'all',
  class_name varchar(48) default NULL,
  template_name varchar(48) default 'default',
  var_name tinyint(1) NOT NULL default '0',
  navorder smallint(5) unsigned NOT NULL default '1',
  pattern varchar(255) default NULL,
  render tinyint(1) NOT NULL default '0',
  render_for tinyint(1) NOT NULL default '0',
  opt_match tinyint(1) NOT NULL default '0',
  owner_id mediumint(8) unsigned NOT NULL default '1',
  group_id mediumint(8) unsigned NOT NULL default '1',
  perm_owner tinyint(1) unsigned NOT NULL default '3',
  perm_group tinyint(1) unsigned NOT NULL default '2',
  perm_members tinyint(1) unsigned NOT NULL default '2',
  perm_anon tinyint(1) unsigned NOT NULL default '2',
  PRIMARY KEY (nid)
) TYPE=MyISAM
";

$_SQL[] = "
CREATE TABLE {$_TABLES['navmmenuitems']} (
  mid varchar(40) NOT NULL default '',
  pmid varchar(40) NOT NULL default '',
  gid tinyint(1) NOT NULL default '1',
  is_enabled tinyint(1) unsigned NOT NULL default '1',
  type varchar(20) NOT NULL default 'custom',
  label varchar(48) default NULL,
  label_var varchar(48) default NULL,
  php_function varchar(48) default NULL,
  url varchar(255) default NULL,
  icon_url varchar(255) default NULL,
  class_name varchar(48) default NULL,
  tid varchar(20) NOT NULL default 'all',
  menuorder smallint(5) unsigned NOT NULL default '1',
  pattern varchar(255) default NULL,
  opt_match tinyint(1) NOT NULL default '0',
  contentid varchar(40) NOT NULL default '',
  owner_id mediumint(8) unsigned NOT NULL default '1',
  group_id mediumint(8) unsigned NOT NULL default '1',
  perm_owner tinyint(1) unsigned NOT NULL default '3',
  perm_group tinyint(1) unsigned NOT NULL default '2',
  perm_members tinyint(1) unsigned NOT NULL default '2',
  perm_anon tinyint(1) unsigned NOT NULL default '2',
  PRIMARY KEY (mid)
) TYPE=MyISAM
";



$_SQL[] = "
INSERT INTO {$_TABLES['navmmenus']} (nid, gid, name, is_enabled, php_function, tid, class_name, template_name, var_name, navorder, pattern, render, render_for, opt_match, owner_id, group_id) VALUES 
('global_navi_1', 0, 'Header Navigation  1', 1, '', 'all', 'navi_001',    'default', 0, 10, '', 0, 0, 0, {$_USER['uid']}, '#group#'),
('global_navi_2', 0, 'Header Navigation  2', 0, '', 'all', 'navi_002',    'default', 0, 20, '', 0, 0, 0, {$_USER['uid']}, '#group#'),
('global_navi_3', 0, 'Header Navigation  3', 0, '', 'all', 'navi_003',    'default', 0, 30, '', 0, 0, 0, {$_USER['uid']}, '#group#'),
('global_navi_4', 1, 'Block Navigation',     0, '', 'all', 'bnavi_001',   'default', 0, 40, '', 0, 2, 0, {$_USER['uid']}, '#group#'),
('breadcrumbs',   2, 'Breadcrumbs',          1, '', 'all', 'breadcrumbs', 'default', 2, 50, '', 1, 0, 0, {$_USER['uid']}, '#group#');
";


$_SQL[] = "
INSERT INTO {$_TABLES['navmmenuitems']} (mid, pmid, gid, is_enabled, type, label, label_var, php_function, url, icon_url, class_name, tid, menuorder, pattern, opt_match, owner_id, group_id, contentid) VALUES 
('home', '', 0, 1, 'gldefault', 'Home', 'LANG01[90]', '', '[site_url]/', '', '', 'all', 10, '[site_url]/', 1, {$_USER['uid']}, '#group#', ''),
('contribute', '', 0, 1, 'gldefault', 'Contribute', 'LANG01[71]', 'contribute', '[site_url]/submit.php?type=story', '', 'drop', 'all', 20, '@/submit\\\\\\\\.php\\\\\\\\?type=story|/admin/story\\\\\\\\.php\\\\\\\\?mode=edit@', 2, {$_USER['uid']}, '#group#', ''),
('prefs', 'contribute', 0, 1, 'gldefault', 'My Account', 'LANG01[48]', '', '[site_url]/usersettings.php?mode=edit', '', '', 'all', 30, '/usersettings.php', 0, {$_USER['uid']}, '#group#', ''),
('login', 'contribute', 0, 1, 'custom', 'Log In', '', 'login', '', '', '', 'all', 40, '', 0, {$_USER['uid']}, '#group#', ''),
('search', '', 0, 1, 'gldefault', 'Advanced Search', 'LANG01[75]', '', '[site_url]/search.php', '', '', 'all', 50, '/search.php', 0, {$_USER['uid']}, '#group#', ''),
('stats', '', 0, 1, 'gldefault', 'Site Statistics', 'LANG01[76]', '', '[site_url]/stats.php', '', '', 'all', 60, '/stats.php', 0, {$_USER['uid']}, '#group#', ''),
('directory', '', 0, 1, 'gldefault', 'Directory', 'LANG01[117]', '', '[site_url]/directory.php', '', '', 'all', 70, '/directory.php', 0, {$_USER['uid']}, '#group#', ''),
('ln_home', '', 1, 1, 'custom', 'Home', 'LANG01[90]', '', '[site_url]/', '', '', 'all', 140, '', 0, {$_USER['uid']}, '#group#', ''),
('ln_search', '', 1, 1, 'custom', 'Advanced Search', 'LANG01[75]', '', '[site_url]/search.php', '', '', 'all', 150, '/search.php', 0, {$_USER['uid']}, '#group#', ''),
('ln_stats', '', 1, 1, 'custom', 'Site Statistics', 'LANG01[76]', '', '[site_url]/stats.php', '', 'drop', 'all', 160, '/stats.php', 0, {$_USER['uid']}, '#group#', ''),
('ln_stats_clone_1', 'ln_stats', 1, 1, 'custom', 'Site Statistics', 'LANG01[76]', '', '[site_url]/stats.php', '', 'fly', 'all', 170, '/stats.php', 0, {$_USER['uid']}, '#group#', ''),
('ln_stats_clone_2', 'ln_stats_clone_1', 1, 1, 'custom', 'Site Statistics', 'LANG01[76]', '', '[site_url]/stats.php', '', '', 'all', 180, '/stats.php', 0, {$_USER['uid']}, '#group#', ''),
('bc_staticpage_spid', '', 2, 1, 'custom', '[BC] Staticpage (sample)', '', 'bc_staticpage', '', '', '', 'all', 190, '@index\\\\\\\\.php(\\\\\\\\?page=|/)spid@', 2, {$_USER['uid']}, '#group#', 'spid'),
('bc_search', '', 2, 1, 'custom', '[BC] Advanced Search', 'LANG01[75]', '', '[site_url]/search.php', '', '', 'all', 200, '/search.php', 0, {$_USER['uid']}, '#group#', ''),
('bc_stats', '', 2, 1, 'custom', '[BC] Site Statistics', 'LANG01[76]', '', '[site_url]/stats.php', '', '', 'all', 210, '/stats.php', 0, {$_USER['uid']}, '#group#', ''),
('bc_directory', '', 2, 1, 'custom', '[BC] Directory', 'LANG01[117]', '', '[site_url]/directory.php', '', '', 'all', 220, '/directory.php', 0, {$_USER['uid']}, '#group#', ''),
('bc_usersettings', '', 2, 1, 'custom', '[BC] My Account', 'LANG01[48]', '', '[site_url]/usersettings.php', '', '', 'all', 230, '/usersettings.php', 0, {$_USER['uid']}, '#group#', ''),
('bc_story_topic', '', 2, 1, 'custom', '[BC] Story Topic', '', 'bc_topic', '', '', '', 'all', 240, '/index.php?topic=', 0, {$_USER['uid']}, '#group#', ''),
('bc_article', 'bc_story_topic', 2, 1, 'custom', '[BC] Article', '', 'bc_article', '', '', '', 'all', 250, '@/article\\\\\\\\.php\\\\\\\\?story=|/article\\\\\\\\.php/@', 2, {$_USER['uid']}, '#group#', ''),
('bc_moderation', '', 2, 1, 'custom', '[BC] Submissions', 'LANG01[10]', '', '[site_url]/admin/moderation.php', '', '', 'all', 260, '/admin/moderation.php', 0, {$_USER['uid']}, '#group#', ''),
('bc_admin_plugin', 'bc_moderation', 2, 1, 'custom', '[BC] Admin plugin', '', 'bc_admin_plugin', '', '', '', 'all', 270, '@/admin/plugins/[^/]+/[^/]+\\\\\\\\.php@', 2, {$_USER['uid']}, '#group#', ''),
('bc_admin', 'bc_moderation', 2, 1, 'custom', '[BC] Admin', '', 'bc_admin', '', '', '', 'all', 280, '@/admin/?([^/]+)\\\\\\\\.php@', 2, {$_USER['uid']}, '#group#', ''),
('bc_links', '', 2, 1, 'custom', '[BC] Links', 'LANG_LINKS[14]', '', '[site_url]/links/index.php', '', '', 'all', 290, '@(?<!plugins)/links/index\\\\\\\\.php$@', 2, {$_USER['uid']}, '#group#', ''),
('bc_links_category', 'bc_links', 2, 1, 'custom', '[BC] Links category', '', 'bc_links_category', '', '', '', 'all', 300, '/links/index.php?category=', 0, {$_USER['uid']}, '#group#', ''),
('bc_polls', '', 2, 1, 'custom', '[BC] Polls', 'LANG_POLLS[''polls'']', '', '[site_url]/polls/index.php', '', '', 'all', 310, '@(?<!plugins)/polls/index\\\\\\\\.php$@', 2, {$_USER['uid']}, '#group#', ''),
('bc_polls_topic', 'bc_polls', 2, 1, 'custom', '[BC] Polls topic', '', 'bc_polls_topic', '', '', '', 'all', 320, '/polls/index.php?pid=', 0, {$_USER['uid']}, '#group#', ''),
('bc_calendar', '', 2, 1, 'custom', '[BC] Calendar', 'LANG_CAL_1[16]', '', '[site_url]/calendar/index.php', '', '', 'all', 330, '@(?<!plugins)/calendar/index\\\\\\\\.php$@', 2, {$_USER['uid']}, '#group#', ''),
('bc_calendar_event', 'bc_calendar', 2, 1, 'custom', '[BC] Calendar event', '', 'bc_calendar_event', '', '', '', 'all', 340, '/calendar/event.php?eid=', 0, {$_USER['uid']}, '#group#', ''),
('bc_calendarjp', '', 2, 1, 'custom', '[BC] Calendarjp', 'LANG_CALJP_1[16]', '', '[site_url]/calendarjp/index.php', '', '', 'all', 350, '@(?<!plugins)/calendarjp/index\\\\\\\\.php$@', 2, {$_USER['uid']}, '#group#', ''),
('bc_calendarjp_event', 'bc_calendarjp', 2, 1, 'custom', '[BC] Calendarjp event', '', 'bc_calendarjp_event', '', '', '', 'all', 360, '/calendarjp/event.php?eid=', 0, {$_USER['uid']}, '#group#', ''),
('bc_forum', '', 2, 1, 'custom', '[BC] Forum', 'LANG_GF01[''INDEXPAGE'']', '', '[site_url]/forum/index.php', '', '', 'all', 370, '@(?<!plugins)/forum/index\\\\\\\\.php$@', 2, {$_USER['uid']}, '#group#', ''),
('bc_forum_category', 'bc_forum', 2, 1, 'custom', '[BC] Forum category', '', 'bc_forum_category', '', '', '', 'all', 380, '', 0, {$_USER['uid']}, '#group#', ''),
('bc_forum_name', 'bc_forum_category', 2, 1, 'custom', '[BC] Forum name', '', 'bc_forum_name', '', '', '', 'all', 390, '/forum/index.php?forum=', 0, {$_USER['uid']}, '#group#', ''),
('bc_forum_topic', 'bc_forum_name', 2, 1, 'custom', '[BC] Forum topic', '', 'bc_forum_topic', '', '', '', 'all', 400, '/forum/viewtopic.php?showtopic=', 0, {$_USER['uid']}, '#group#', ''),
('bc_forum_etc', 'bc_forum', 2, 1, 'custom', '[BC] Forum etc', '', 'bc_forum_etc', '[site_url]/forum/index.php', '', '', 'all', 410, '@(?<!plugins)/forum/(index|userprefs|notify|memberlist)\\\\\\\\.php@', 2, {$_USER['uid']}, '#group#', ''),
('bc_filemgmt', '', 2, 1, 'custom', '[BC] Filemgmt', 'LANG_FILEMGMT[''downloads'']', '', '[site_url]/filemgmt/index.php', '', '', 'all', 420, '@(?<!plugins)/filemgmt/index\\\\\\\\.php$@', 2, {$_USER['uid']}, '#group#', ''),
('bc_filemgmt_category', 'bc_filemgmt', 2, 1, 'custom', '[BC] Filemgmt category', '', 'bc_filemgmt_category', '', '', '', 'all', 430, '/filemgmt/viewcat.php?cid=', 0, {$_USER['uid']}, '#group#', ''),
('bc_filemgmt_file', 'bc_filemgmt_category', 2, 1, 'custom', '[BC] Filemgmt file', '', 'bc_filemgmt_file', '', '', '', 'all', 440, '@/filemgmt/index\\\\\\\\.php\\\\\\\\.?id=|/filemgmt/index\\\\\\\\.php/@', 2, {$_USER['uid']}, '#group#', ''),
('bc_dokuwiki', '', 2, 1, 'custom', '[BC] Dokuwiki', 'LANG_DW00[''menulabel'']', '', '[site_url]/dokuwiki/doku.php', '', '', 'all', 450, '@(?<!plugins)/dokuwiki/doku\\\\\\\\.php$@', 2, {$_USER['uid']}, '#group#', ''),
('bc_downloads', '', 2, 1, 'custom', '[BC] Downloads', 'LANG_DLM[''plugin_name'']', '', '[site_url]/downloads/index.php', '', '', 'all', 460, '@(?<!plugins)/downloads/index\\\\\\\\.php$@', 2, {$_USER['uid']}, '#group#', ''),
('bc_downloads_category', 'bc_downloads', 2, 1, 'custom', '[BC] Downloads category', '', 'bc_downloads_category', '', '', '', 'all', 470, '/downloads/index.php?cid=', 0, {$_USER['uid']}, '#group#', ''),
('bc_downloads_file', 'bc_downloads_category', 2, 1, 'custom', '[BC] Downloads file', '', 'bc_downloads_file', '', '', '', 'all', 480, '@/downloads/index\\\\\\\\.php\\\\\\\\?id=|/downloads/index\\\\\\\\.php/@', 2, {$_USER['uid']}, '#group#', ''),
('bc_mediagallery', '', 2, 1, 'custom', '[BC] Mediagallery', 'LANG_MG00[''plugin'']', '', '[site_url]/mediagallery/index.php', '', '', 'all', 490, '@(?<!plugins)/mediagallery/index\\\\\\\\.php@', 2, {$_USER['uid']}, '#group#', ''),
('bc_mediagallery_album', 'bc_mediagallery', 2, 1, 'custom', '[BC] Mediagallery album', '', 'bc_mediagallery_album', '', '', '', 'all', 500, '/mediagallery/album.php', 0, {$_USER['uid']}, '#group#', ''),
('bc_mediagallery_media', 'bc_mediagallery_album', 2, 1, 'custom', '[BC] Mediagallery media', '', 'bc_mediagallery_media', '', '', '', 'all', 510, '/mediagallery/media.php', 0, {$_USER['uid']}, '#group#', '');
";

?>
